﻿using System.Collections.ObjectModel;

namespace TestProject
{
    /// <summary>
    /// 컨트롤 정보 데이터 그룹
    /// </summary>
    public class ControlInfoDataGroup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 고유 ID - UniqueID

        /// <summary>
        /// 고유 ID
        /// </summary>
        public string UniqueID { get; private set; }

        #endregion
        #region 제목 - Title

        /// <summary>
        /// 제목
        /// </summary>
        public string Title { get; private set; }

        #endregion
        #region 하위 제목 - Subtitle

        /// <summary>
        /// 하위 제목
        /// </summary>
        public string Subtitle { get; private set; }

        #endregion
        #region 설명 - Description

        /// <summary>
        /// 설명
        /// </summary>
        public string Description { get; private set; }

        #endregion
        #region 이미지 경로 - ImagePath

        /// <summary>
        /// 이미지 경로
        /// </summary>
        public string ImagePath { get; private set; }

        #endregion
        #region 데이터 항목 컬렉션 - DataItemCollection

        /// <summary>
        /// 데이터 항목 컬렉션
        /// </summary>
        public ObservableCollection<ControlInfoDataItem> DataItemCollection { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ControlInfoDataGroup(uniqueID, title, subtitle, imagePath, description)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="uniqueID">고유 ID</param>
        /// <param name="title">제목</param>
        /// <param name="subtitle">하위 제목</param>
        /// <param name="imagePath">이미지 경로</param>
        /// <param name="description">설명</param>
        public ControlInfoDataGroup(string uniqueID, string title, string subtitle, string imagePath, string description)
        {
            UniqueID           = uniqueID;
            Title              = title;
            Subtitle           = subtitle;
            Description        = description;
            ImagePath          = imagePath;
            DataItemCollection = new ObservableCollection<ControlInfoDataItem>();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            return Title;
        }

        #endregion
    }
}