﻿using System.Collections.ObjectModel;

namespace TestProject
{
    /// <summary>
    /// 컨트롤 정보 데이터 항목
    /// </summary>
    public class ControlInfoDataItem
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 고유 ID - UniqueID

        /// <summary>
        /// 고유 ID
        /// </summary>
        public string UniqueID { get; private set; }

        #endregion
        #region 제목 - Title

        /// <summary>
        /// 제목
        /// </summary>
        public string Title { get; private set; }

        #endregion
        #region 하위 제목 - Subtitle

        /// <summary>
        /// 하위 제목
        /// </summary>
        public string Subtitle { get; private set; }

        #endregion
        #region 설명 - Description

        /// <summary>
        /// 설명
        /// </summary>
        public string Description { get; private set; }

        #endregion
        #region 이미지 경로 - ImagePath

        /// <summary>
        /// 이미지 경로
        /// </summary>
        public string ImagePath { get; private set; }

        #endregion
        #region 배지 문자열 - BadgeString

        /// <summary>
        /// 배지 문자열
        /// </summary>
        public string BadgeString { get; private set; }

        #endregion
        #region 내용 - Content

        /// <summary>
        /// 내용
        /// </summary>
        public string Content { get; private set; }

        #endregion
        #region 신규 여부 - IsNew

        /// <summary>
        /// 신규 여부
        /// </summary>
        public bool IsNew { get; private set; }

        #endregion
        #region 업데이트 여부 - IsUpdated

        /// <summary>
        /// 업데이트 여부
        /// </summary>
        public bool IsUpdated { get; private set; }

        #endregion
        #region 미리보기 여부 - IsPreview

        /// <summary>
        /// 미리보기 여부
        /// </summary>
        public bool IsPreview { get; private set; }

        #endregion
        #region 문서 링크 컬렉션 - DocumentLinkCollection

        /// <summary>
        /// 문서 링크 컬렉션
        /// </summary>
        public ObservableCollection<ControlInfoDocumentLink> DocumentLinkCollection { get; private set; }

        #endregion
        #region 연결 컨트롤 컬렉션 - RelatedControlCollection

        /// <summary>
        /// 연결 컨트롤 컬렉션
        /// </summary>
        public ObservableCollection<string> RelatedControlCollection { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ControlInfoDataItem(uniqueID, title, subtitle, imagePath, badgeString, description, content, isNew, isUpdated, isPreview)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="uniqueID">고유 ID</param>
        /// <param name="title">제목</param>
        /// <param name="subtitle">하위 제목</param>
        /// <param name="imagePath">이미지 경로</param>
        /// <param name="badgeString">배지 문자열</param>
        /// <param name="description">설명</param>
        /// <param name="content">내용</param>
        /// <param name="isNew">신규 여부</param>
        /// <param name="isUpdated">업데이트 여부</param>
        /// <param name="isPreview">미리보기 여부</param>
        public ControlInfoDataItem
        (
            string uniqueID,
            string title,
            string subtitle,
            string imagePath,
            string badgeString,
            string description,
            string content,
            bool   isNew,
            bool   isUpdated,
            bool   isPreview
        )
        {
            UniqueID                 = uniqueID;
            Title                    = title;
            Subtitle                 = subtitle;
            ImagePath                = imagePath;
            BadgeString              = badgeString;
            Description              = description;
            Content                  = content;
            IsNew                    = isNew;
            IsUpdated                = isUpdated;
            IsPreview                = isPreview;
            DocumentLinkCollection   = new ObservableCollection<ControlInfoDocumentLink>();
            RelatedControlCollection = new ObservableCollection<string>();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            return Title;
        }

        #endregion
    }
}